#include <stdio.h>
#include <math.h>
#define DIR "/line6/cat"
#define ndate 90
int obsdate[ndate]={ 101002,101003,101004,                              //2010
                     101103,101104,101105,101106,101107,101108,
                     101204,101205,101206,101207,101208,101209,
                     110918,110919,110920,110921,110922,110923,110924,  //2011
                     111024,111025,111026,111027,111028,111029,111030,111031,
                     111123,111124,111126,111127,111128,111129,111130,111201,
                     111224,111226,111227,111228,111229,111230,111231,120101,
                     120918,120919,120920,120921,                       //2012
                     121009,121010,121011,121012,121013,121014,121015,121016,
                                          121017,121018,121019,121020,121021,
                     121112,121113,121114,121115,                       //2013
                     130911,130925,130926,130928,130929,130930,131001,131002,
                     131003,131004,131005,131006,131007,131008,131009,
                     131030,131031,131101,131102,131103,131104,131106,
                     131222 };

char head[72][80];
FILE *fp,*fp1,*fp2;

main(int ac,char **av)
{
  char a[120],f1[50],t[80], obj[8];
  int ip,i,j,k,ie,jp, usl,u1,u3;
  float c1,c3,r1,r3, sky,see, a1,a2,a3,a4;
  if(ac<2){ printf("\n\t*** produce nfits62.cali ******\n");
            printf("\n\t after addcali+starcali\n");
            exit(0); }
  fp2=fopen("nfits62.cali","w");
  fprintf(fp2,"#   date/name       usl bertin  rms  matched  sky  see");
  fprintf(fp2,"   A73  rms  match  a731  a732  a733  a734  exp  obj\n#"); 
  for(i=0;i<105;i++)fprintf(fp2,"-"); fprintf(fp2,"\n");
  for(ip=0;ip<ndate;ip++){ jp=0;
    printf("%d\n",obsdate[ip]);
    sprintf(a,"ls %s/%d/p*.fit >1.1",DIR,obsdate[ip]);
    system(a);
    fp1=fopen("1.1","r");
l10:
    fgets(a,120,fp1); if(feof(fp1))goto l20;
    strcpy(f1,a); k=strlen(f1); f1[k-1]=0;
    fp=fopen(f1,"rb");  jp++;
    fread(head,72,80,fp); fclose(fp);
    c1=r1=0; u1=usl=0;
    k=indexpos(head,"CALIBRAT",72);
    if(k!=72){
      sscanf(&head[k][20],"%f",&c1);
      sscanf(&head[k][37],"%f",&r1);
      if(head[k][36]!=32){
        sscanf(&head[k][48],"%d",&usl);
        sscanf(&head[k][62],"%d",&u1);
      }
    }
    k=indexpos(head,"SKYADU  ",72);
    sscanf(&head[k][20],"%f",&sky);
    sscanf(&head[k+1][20],"%f",&see);
    k=indexpos(head,"EXPTIME ",72);
    sscanf(&head[k][20],"%f",&c3); ie=c3+0.5;
    k=indexpos(head,"OBJECT  ",72);
    for(i=0;i<7;i++)obj[i]=head[k][i+11]; obj[i]=0;
    
    u3=0; c3=r3=a1=a2=a3=a4=0;
    i=strlen(DIR)+1; f1[i+19]=0;
    if(head[60][29]!=32){
      sscanf(&head[60][20],"%f",&c3);
      sscanf(&head[60][37],"%f",&r3);
      if(head[60][36]!=32)sscanf(&head[60][62],"%d",&u3); 
      else {
        for(j=42;j<66;j++)if(head[60][j]<48 || head[60][j]>57)head[60][j]=32;
        sscanf(&head[60][42],"%d%d%d",&usl,&u1,&k); // nccd,star,iturn
        if(usl>9)usl=9; usl=usl*100+k; usl=-usl;  
      }
    }
    if(head[61][29]!=32)sscanf(&head[61][20],"%f",&a1); 
    if(head[62][29]!=32)sscanf(&head[62][20],"%f",&a2); 
    if(head[63][29]!=32)sscanf(&head[63][20],"%f",&a3);
    if(head[64][29]!=32)sscanf(&head[64][20],"%f",&a4);
    fprintf(fp2,"%s%5d%7.3f%6.3f%5d%8.2f%5.2f%6.3f%6.3f%5d%6.3f%6.3f%6.3f%6.3f%4d %s\n",
          &f1[i],usl,c1,r1,u1,sky,see,c3,r3,u3,a1,a2,a3,a4,ie,obj);
    goto l10;
l20:
    fclose(fp1); 
  }
  fclose(fp2);
  printf("\n\t nfits62.cali  produced !\n");
}
